// ActiveMail.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//		To build a separate proxy/stub DLL, 
//		run nmake -f ActiveMailps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include "initguid.h"
#include "ActiveMail.h"

#include "ActiveMail_i.c"
#include "SMTPMailer.h"
#include "POP3Connection.h"
#include "MessageParser.h"
#include "FTPLogin.h"


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_SMTPMailer, CSMTPMailer)
	OBJECT_ENTRY(CLSID_POP3Connection, CPOP3Connection)
	OBJECT_ENTRY(CLSID_MessageParser, CMessageParser)
	OBJECT_ENTRY(CLSID_FTPLogin, CFTPLogin)
END_OBJECT_MAP()

class CActiveMailApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
};

CActiveMailApp theApp;

BOOL CActiveMailApp::InitInstance()
{
	_Module.Init(ObjectMap, m_hInstance);
	AfxSocketInit();
	return CWinApp::InitInstance();
}

int CActiveMailApp::ExitInstance()
{
	_Module.Term();
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return (AfxDllCanUnloadNow()==S_OK && _Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
	// registers object, typelib and all interfaces in typelib
	return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	_Module.UnregisterServer();
	return S_OK;
}


