// FTPLogin.h : Declaration of the CFTPLogin

#ifndef __FTPLOGIN_H_
#define __FTPLOGIN_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CFTPLogin
class ATL_NO_VTABLE CFTPLogin : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CFTPLogin, &CLSID_FTPLogin>,
	public IDispatchImpl<IFTPLogin, &IID_IFTPLogin, &LIBID_ACTIVEMAILLib>
{
public:
	CFTPLogin()
	{
	  ErrorMessage = (char *) malloc(1);
	  ErrorMessage[0] = '\0';
	  lpszServerName = (char *) malloc(4);
	  lstrcpy(lpszServerName, "ftp");
	  ErrorCode = -1;
	}
	~CFTPLogin()
	{
	  free(ErrorMessage);
	  free(lpszServerName);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_FTPLOGIN)

BEGIN_COM_MAP(CFTPLogin)
	COM_INTERFACE_ENTRY(IFTPLogin)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IFTPLogin
public:
	STDMETHOD(get_Authenticate)(BSTR UserName, BSTR Password, /*[out, retval]*/ BOOL *pVal);
	LPTSTR ErrorMessage;
	int ErrorCode;
	STDMETHOD(get_ErrorMessage)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_ErrorCode)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_ServerName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_ServerName)(/*[in]*/ BSTR newVal);
	LPTSTR lpszServerName;
private:
	static int GetResponseCode(CSocket *pSocket);
	BOOL EmitErrorMessage(LPCTSTR message, int code);
};

#endif //__FTPLOGIN_H_
