// POP3Connection.h : Declaration of the CPOP3Connection

#ifndef __POP3CONNECTION_H_
#define __POP3CONNECTION_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CPOP3Connection
class ATL_NO_VTABLE CPOP3Connection : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPOP3Connection, &CLSID_POP3Connection>,
	public IDispatchImpl<IPOP3Connection, &IID_IPOP3Connection, &LIBID_ACTIVEMAILLib>
{
public:
	CPOP3Connection()
	{
	  ErrorMessage = (char *) malloc(1);
	  ErrorMessage[0] = '\0';
	  lpszServerName = (char *) malloc(5);
	  lstrcpy(lpszServerName, "mail");
	  ErrorCode = -1;
	  connected = false;
	  dwMailboxLength = 0;
	  nMessages = 0;
	  msgData = NULL;
	  lpdwMessageLengths = NULL;
	  lpdwMessageIDs = NULL;
	}
	~CPOP3Connection()
	{
	  if (connected)
		this->Close();
	  free(ErrorMessage);
	  free(lpszServerName);
	  if (msgData) {
		DWORD i;
		for (i = 0; i < nMessages; i++) {
		  if (msgData[i] != NULL)
			delete msgData[i];
		}
		free(msgData);
	  }
	  if (lpdwMessageLengths)
		free(lpdwMessageLengths);
	  if (lpdwMessageIDs)
		free(lpdwMessageIDs);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_POP3CONNECTION)

BEGIN_COM_MAP(CPOP3Connection)
	COM_INTERFACE_ENTRY(IPOP3Connection)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IPOP3Connection
public:
	STDMETHOD(Uncache)(long MessageNumber);
	STDMETHOD(Undelete)();
	STDMETHOD(Idle)();
	STDMETHOD(Delete)(long MessageNumber);
	STDMETHOD(get_MessageLength)(long MessageNumber, /*[out, retval]*/ long *pVal);
	STDMETHOD(get_Message)(long MessageNumber, /*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_MailboxLength)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_MessageCount)(/*[out, retval]*/ long *pVal);
	STDMETHOD(Close)();
	STDMETHOD(Connect)(BSTR UserName, BSTR Password);
	STDMETHOD(get_ServerName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_ServerName)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_ErrorMessage)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_ErrorCode)(/*[out, retval]*/ long *pVal);
	LPSTR lpszServerName;
	LPTSTR ErrorMessage;
	int ErrorCode;
private:
	LPDWORD lpdwMessageIDs;
	BOOL ReadServerLine(LPBOOL lpbEnd);
	CString **msgData;
	LPDWORD lpdwMessageLengths;
	DWORD dwMailboxLength;
	DWORD nMessages;
	BOOL connected;
	CString inputBuffer;
	CSocket pSocket;
	BOOL ReadResponse(LPBOOL lpbOk);
	BOOL EmitErrorMessage(LPCTSTR message, int code);
};

#endif //__POP3CONNECTION_H_
