// SMTPMailer.h : Declaration of the CSMTPMailer

#ifndef __SMTPMAILER_H_
#define __SMTPMAILER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CSMTPMailer
class ATL_NO_VTABLE CSMTPMailer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSMTPMailer, &CLSID_SMTPMailer>,
	public IDispatchImpl<ISMTPMailer, &IID_ISMTPMailer, &LIBID_ACTIVEMAILLib>
{
public:
	CSMTPMailer()
	{
	  IgnoreTo = FALSE;
	  ErrorMessage = (char *) malloc(1);
	  ErrorMessage[0] = '\0';
	  lpszServerName = (char *) malloc(5);
	  lstrcpy(lpszServerName, "mail");
	  ErrorCode = -1;
	}

	~CSMTPMailer()
	{
	  free(ErrorMessage);
	  free(lpszServerName);
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SMTPMAILER)

BEGIN_COM_MAP(CSMTPMailer)
	COM_INTERFACE_ENTRY(ISMTPMailer)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ISMTPMailer
public:
	STDMETHOD(get_ServerName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_ServerName)(/*[in]*/ BSTR newVal);
	LPSTR lpszServerName;
	BOOL IgnoreTo;
	LPTSTR ErrorMessage;
	int ErrorCode;
	STDMETHOD(get_ErrorMessage)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_ErrorCode)(/*[out, retval]*/ long *pVal);
	STDMETHOD(SendRawMessage)(BSTR Message);
	STDMETHOD(get_IgnoreTo)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_IgnoreTo)(/*[in]*/ BOOL newVal);
	STDMETHOD(SendMessage)(BSTR From, BSTR To, BSTR Cc, BSTR Bcc, BSTR Subject, BSTR Message);
	STDMETHOD(SendMessageFromFile)(BSTR From, BSTR To, BSTR Cc, BSTR Bcc, BSTR Subject, BSTR FileName);
//	STDMETHOD(get_Server)(/*[out, retval]*/ BSTR *pVal);
//	STDMETHOD(put_Server)(/*[in]*/ BSTR newVal);
	STDMETHOD(SendRawMessageFromFile)(BSTR FileName);
private:
	BOOL EmitErrorMessage(LPCTSTR message, int code);
    int GetResponseCode(CSocket *pSocket);
	BOOL ReadLine(CFile *pFile, CString *inputBuffer);
	BOOL ReadList(CString *inputBuffer, CObArray *list);
	BOOL ReadListFromFile(CFile *pFile, CString *inputBuffer, CObArray *list);
	BOOL SendFromAndTo(CSocket *pSocket, CString *from, CObArray *to);
	BOOL ParseRawHeader(CFile *pFile, CSocket *pSocket, DWORD *excludeStart, DWORD *excludeEnd);
};

#endif //__SMTPMAILER_H_
